=== benchmarks/compile_time/CMakeLists.txt ===
add_subdirectory(qwrapper)

add_executable(BENCHMARK_quill_compile_time compile_time_bench.cpp)
set_common_compile_options(BENCHMARK_quill_compile_time)
target_link_libraries(BENCHMARK_quill_compile_time qwrapper_compile_time_bench)
