=== benchmarks/hot_path_latency/CMakeLists.txt ===
add_executable(BENCHMARK_quill_hot_path_rdtsc_clock hot_path_bench_config.h hot_path_bench.h quill_hot_path_rdtsc_clock.cpp)
set_common_compile_options(BENCHMARK_quill_hot_path_rdtsc_clock)
target_link_libraries(BENCHMARK_quill_hot_path_rdtsc_clock quill)

add_executable(BENCHMARK_quill_hot_path_system_clock hot_path_bench_config.h hot_path_bench.h quill_hot_path_system_clock.cpp)
set_common_compile_options(BENCHMARK_quill_hot_path_system_clock)
target_link_libraries(BENCHMARK_quill_hot_path_system_clock quill)
