=== debian/changelog ===
quill (10.2.0-1) unstable; urgency=medium

  * Initial release (Closes: #1078353).
  * Remove doctest embedded source dependency.
  * Fix pattern formatter test source location prefix repo root path.
  * Updated d/watch file format to version 5.

 -- Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>  Wed, 29 Oct 2025 10:34:06 +0500
