=== debian/control ===
Source: quill
Section: libs
Priority: optional
Maintainer: Syed Shahrukh Hussain <syed.shahrukh@ossrevival.org>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 doctest-dev <!nocheck>,
Standards-Version: 4.7.2
Homepage: https://github.com/odygrd/quill
Vcs-Browser: https://salsa.debian.org/syed/quill
Vcs-Git: https://salsa.debian.org/syed/quill.git

Package: quill-dev
Section: libdevel
Architecture: any
Depends:
	${misc:Depends},
Description: Asynchronous Low Latency C++ Logging Library
 Quill is a high-performance, header-only logging library for C++17 and
 onwards, specifically designed for low-latency applications. It provides
 asynchronous logging capabilities, making it suitable for real-time systems
 where minimal delay is critical. This package would be beneficial for
 developers working on performance-sensitive C++ applications.
