=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

QUILL_BUILD_TESTS = "-DQUILL_BUILD_TESTS=OFF"
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	QUILL_BUILD_TESTS = "-DQUILL_BUILD_TESTS=ON"
endif

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH) \
	$(QUILL_BUILD_TESTS)
