=== test/CMakeLists.txt ===
add_subdirectory(unit_tests)
add_subdirectory(integration_tests)
