=== docs/examples/CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
         quill_docs_example_multiple_sinks
         quill_docs_example_multiple_sinks_tags
         quill_docs_example_tags_with_custom_sink
+        quill_docs_quick_start
         quill_docs_timestamp_types_1
 )
