=== debian/tests/control ===
Tests: upstream-tests
Depends: @, build-essential, cmake, doctest-dev
